; 
    include \masm32\include\masm32rt.inc
    include \masm32\macros\ucmacros.asm
    .686
    .XMM

    include timers.asm

    StrLenW PROTO:DWORD
    Lingo32W PROTO:DWORD
    ucLen2 PROTO:DWORD
    Edu32W PROTO:DWORD
    Edu32W2 PROTO:DWORD
    EduSSE PROTO:DWORD
    SebW PROTO :DWORD
    SebW2 PROTO :DWORD
; 
    .data
      WSTR ws, "my other brother darryl"
    .code
; 
start:
; 
    invoke crt_printf, chr$("%S%c"),ADDR ws,10
    
    print "LENGTHOF : "
    print ustr$(LENGTHOF ws),13,10
    print "SIZEOF : "
    print ustr$(SIZEOF ws),13,10

    invoke StrLenW, ADDR ws
    push  eax
    print "StrLenW return value : "
    pop   eax
    print ustr$(eax),13,10

    invoke Lingo32W, ADDR ws
    push  eax
    print "Lingo32W return value : "
    pop   eax
    print ustr$(eax),13,10

    invoke ucLen2, ADDR ws
    push  eax
    print "ucLen2 return value : "
    pop   eax
    print ustr$(eax),13,10

    invoke Edu32W, ADDR ws
    push  eax
    print "Edu32W return value : "
    pop   eax
    print ustr$(eax),13,10 

    invoke Edu32W2, ADDR ws
    push  eax
    print "Edu32W2 return value : "
    pop   eax
    print ustr$(eax),13,10 

    invoke EduSSE, ADDR ws
    push  eax
    print "EduSSE return value : "
    pop   eax
    print ustr$(eax),13,10

    invoke SebW, ADDR ws
    push  eax
    print "SebW return value : "
    pop   eax
    print ustr$(eax),13,10

    invoke SebW2, ADDR ws
    push  eax
    print "SebW2 return value : "
    pop   eax
    print ustr$(eax),13,10

    print "StrLenW : "
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke StrLenW, ADDR ws
    counter_end
    print ustr$(eax)," cycles",13,10

    print "Lingo32W : "
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke Lingo32W, ADDR ws
    counter_end
    print ustr$(eax)," cycles",13,10

    print "ucLen2 : "
    LOOP_COUNT equ 10000000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke ucLen2, ADDR ws
    counter_end
    print ustr$(eax)," cycles",13,10

    print "Edu32W : "
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke Edu32W, ADDR ws
    counter_end
    print ustr$(eax)," cycles",13,10 

    print "Edu32W2 : "
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke Edu32W2, ADDR ws
    counter_end
    print ustr$(eax)," cycles",13,10 
    
    print "EduSSE : "
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke EduSSE, ADDR ws
    counter_end
    print ustr$(eax)," cycles",13,10

    print "SebW : "
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke SebW, ADDR ws
    counter_end
    print ustr$(eax)," cycles",13,10

    print "SebW2 : "
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke SebW2, ADDR ws
    counter_end
    print ustr$(eax)," cycles",13,10,13,10

    inkey "Press any key to exit..."
    exit

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

;00401680 8B442404               mov     eax,[esp+4]
;00401684 83E808                 sub     eax,8
;00401687                    loc_00401687:
;00401687 83C008                 add     eax,8
;0040168A 66833800               cmp     word ptr [eax],0
;0040168E 7439                   jz      loc_004016C9
;00401690 6683780200             cmp     word ptr [eax+2],0
;00401695 7426                   jz      loc_004016BD
;00401697 6683780400             cmp     word ptr [eax+4],0
;0040169C 7413                   jz      loc_004016B1
;0040169E 6683780600             cmp     word ptr [eax+6],0
;004016A3 75E2                   jnz     loc_00401687

align 16
;
; Return characters length of lpszStr excluding zero-terminated char
;
StrLenW proc public p_lpszStr:dword

   mov eax, [esp+4]
   sub eax, 8
@@:
   add eax, 8
   cmp word ptr [eax], 0
   je Add0
   cmp word ptr [eax+2], 0
   je Add1
   cmp word ptr [eax+4], 0
   je Add2
   cmp word ptr [eax+6], 0
   jne @B

   sub eax, [esp+4]
   shr eax, 1
   add eax, 3
   ret 4

Add2:
   sub eax, [esp+4]
   shr eax, 1
   add eax, 2
   ret 4

Add1:
   sub eax, [esp+4]
   shr eax, 1
   add eax, 1
   ret 4

Add0:
   sub eax, [esp+4]
   shr eax, 1
   ret 4

StrLenW endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

ucLen2 proc lpwstr:DWORD

    mov ecx, [esp+4]    ; lpwstr
    xor eax, eax
    sub ecx, 4

  lbl0:
    add ecx, 4
    mov eax, [ecx]
    cmp ax, 0
    je lbl1
    rol eax, 16
    cmp ax, 0
    jne lbl0

    sub ecx, [esp+4]    ; lpwstr
    mov eax, ecx
    shr eax, 1
    add eax, 1
    ret 4

  lbl1:
    sub ecx, [esp+4]    ; lpwstr
    mov eax, ecx
    shr eax, 1
    ret 4

ucLen2 endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

OPTION PROLOGUE:NONE          ; turn it off
OPTION EPILOGUE:NONE

align 16

Lingo32W                proc  lpst:DWORD
                        mov   eax, [esp+4]
                        mov   edx, 80008000h
                        mov   ecx, [eax]
@@:
                        add   eax, 4
                        add   ecx, 0FEFFFF00h
                        test  edx, ecx
                        mov   ecx, [eax]
                        je    @b

                        test  word ptr [eax-4], 0FFFFh
                        je    C_minus4 
                        test  word ptr [eax-4+2], 0FFFFh
                        je    C_minus2
@@:
                        and   ecx, 07F7F7F7FH
                        add   eax, 4
                        add   ecx, 0FEFFFF00h
                        test  ecx, edx
                        mov   ecx, [eax]
                        je    @b

                        test  word ptr [eax-4], 0FFFFh
                        je    C_minus4 
			test  word ptr [eax-4+2], 0FFFFh
                        jne   @b
C_minus2:
                        sub   eax, [esp+4]
                        add   eax, 2-4
                        shr   eax,1
                        ret   4
C_minus4:
                        sub   eax, [esp+4]
                        add   eax,0-4
                        shr   eax,1
                        ret   4
Lingo32W                endp

OPTION PROLOGUE:PROLOGUEDEF   ; turn back on the defaults
OPTION EPILOGUE:EPILOGUEDEF

; 

OPTION PROLOGUE:NONE          ; turn it off
OPTION EPILOGUE:NONE

Edu32W proc src:DWORD
    mov eax, [esp+4]
    @@:
    mov edx, [eax]
    mov ecx, [eax+4]
    test dx, dx
    lea eax,[eax+2]
    jz @F
    shr edx, 16
    lea eax,[eax+2]
    jz @F
    test cx, cx
    lea eax,[eax+2]
    jz @F
    shr ecx, 16
    lea eax,[eax+2]
    jnz @B
    @@:
    sub eax, [esp+4]
    shr eax, 1
    dec eax 
    ret 4
Edu32W endp

OPTION PROLOGUE:PROLOGUEDEF   ; turn back on the defaults
OPTION EPILOGUE:EPILOGUEDEF


; 

OPTION PROLOGUE:NONE          ; turn it off
OPTION EPILOGUE:NONE

Edu32W2 proc src:DWORD
    mov eax, [esp+4]
    @@:
    mov edx, [eax]
    mov ecx, [eax+4]
    test dx, dx
    lea eax, [eax+8]
    jz sub8
    shr edx, 16
    jz sub6
    test cx, cx
    jz sub4
    shr ecx, 16
    jnz @B
    sub eax, 2
    sub eax, [esp+4]
    shr eax, 1
    ret 4
    
    sub4:
    sub eax, 4
    sub eax, [esp+4]
    shr eax, 1
    ret 4
    
    sub6:
    sub eax, 6
    sub eax, [esp+4]
    shr eax, 1
    ret 4
    
    sub8:
    sub eax, 8
    sub eax, [esp+4]
    shr eax, 1
    ret 4
    
Edu32W2 endp

OPTION PROLOGUE:PROLOGUEDEF   ; turn back on the defaults
OPTION EPILOGUE:EPILOGUEDEF


; 

OPTION PROLOGUE:NONE          ; turn it off
OPTION EPILOGUE:NONE

EduSSE proc src:DWORD
    mov eax, [esp+4]
    pxor MM0, MM0

    @@:
    movq MM1, [eax]
    movq MM2, [eax+8]
    add eax, 16
    packsswb MM1, MM2
    pcmpeqb MM1, MM0
    pmovmskb edx, MM1
    test edx, edx
    jz @B
    
    sub eax, [esp+4]
    bsf edx, edx
    shr eax, 1
    lea eax, [eax+edx-8]
    ret 4
EduSSE endp

OPTION PROLOGUE:PROLOGUEDEF   ; turn back on the defaults
OPTION EPILOGUE:EPILOGUEDEF

OPTION PROLOGUE:NONE          ; turn it off
OPTION EPILOGUE:NONE

SebW proc src:DWORD
	mov eax,[esp+4]
	xor ecx,ecx

	align 16
@@:
	cmp word ptr [eax],0
	jz @F
	add ecx,1
	cmp word ptr [eax+2],0
	jz @F
	add ecx,1
	cmp word ptr [eax+4],0
	jz @F
	add ecx,1
	cmp word ptr [eax+6],0
	jz @F
	add ecx,1
	add eax,8
	jmp @B
@@:
	mov eax,ecx
	ret 4
SebW endp

OPTION PROLOGUE:PROLOGUEDEF   ; turn back on the defaults
OPTION EPILOGUE:EPILOGUEDEF

OPTION PROLOGUE:NONE          ; turn it off
OPTION EPILOGUE:NONE

SebW2 proc src:DWORD
	mov eax,[esp+4]
	mov ecx,eax

	align 16
@@:
	add eax,2
	cmp word ptr [eax],0
	jz @F
	add eax,2
	cmp word ptr [eax],0
	jz @F
	add eax,2
	cmp word ptr [eax],0
	jz @F
	add eax,2
	cmp word ptr [eax],0
	jnz @B
@@:
	sub eax,ecx
	shr eax,1
	ret 4
SebW2 endp

OPTION PROLOGUE:PROLOGUEDEF   ; turn back on the defaults
OPTION EPILOGUE:EPILOGUEDEF

; 

end start

